/**
 * Created by Administrator on 2017/2/13.
 */

var $IMG = {
    //选择图片
    selectPic: function (callBack, rotate, multiple) {
        var self = this;
        var cb = callBack || function () {};
        plus.nativeUI.actionSheet({
            title: "选择照片",
            cancel: "取消",
            buttons: [{title: "相机"}, {title: "从手机相册选择"}]
        }, function (e) {
            var index = e.index;
            switch (index) {
                case 1:
                    if(!multiple){
                        self.Camera(function(src){
                            cb(src)
                        }, rotate);
                    }else{
                        self.Camera(function(src){
                            self.files.push(src);
                            cb()
                        }, rotate);
                    }
                    break;
                case 2:
                    !multiple ? self.Gallery(cb, rotate) : self.GalleryS(cb, rotate);
                    break;
            }
        });
    },
    getImage: function () {
        return new Promise(function (resolve, reject) {
            var c = plus.camera.getCamera();
            c.captureImage(function (e) {
                plus.io.resolveLocalFileSystemURL(e, function (entry) {
                    resolve(entry);
                }, function (e) {
                    reject("读取拍照文件错误：" + e.message);
                });
            }, function (s) {
                reject(s);
            }, {
                filename: "_doc/IMG" + (+new Date()) + ".jpg"
            })
        });
    },
    getGallery: function () {
        return new Promise(function (resolve, reject) {
            plus.gallery.pick(function (e) {
                resolve(e);
            }, function (e) {
                reject(e);
            }, {
                filter: "image",
                multiple: false
            });
        });
    },
    compressImage: function (src, name, rotate) {
        return new Promise(function (resolve, reject) {
            plus.zip.compressImage({
                src: src,
                dst: '_doc/' + name,
                overwrite: true,
                quality: 50
            }, function (Img) {
                resolve(Img.target);
            }, function () {
                reject()
            });
        });
    },
    Camera: function (callback) {
        var self = this;
        this.getImage().then(function (f) {
            return self.compressImage(f.toLocalURL(), f.name);
        },function(e){
            console.log('code src 74:' + e);
        }).then(function (src) {
            callback(src);
        }).catch(function (err) {
            console.log('code:' + err);
        });
    },
    //相册单选
    Gallery: function (callback) {
        var self = this;
        this.getGallery().then(function (f) {
            var name = f.split('/');
            name = name[name.length - 1];
            return self.compressImage(f, name);
        }).then(function (src) {
            callback(src);
        }).catch(function (err) {
            console.log(err);
        });
    },
    count: 10,
    files: [],
    pendingFiles: [],
    //相册多选
    GalleryS: function (callback) {
        var self = this;
        plus.gallery.pick(function (e) {
            self.pendingFiles = e.files;
            self.ZIP(callback);
        }, function (e) {
            //$.toast(JSON.stringify(e));
        }, {
            filter: "image",
            maximum: self.count - self.files.length,
            multiple: true,
            onmaxed: function () {
                plus.nativeUI.toast('最多选择10张图片');
            }
        });
    },
    ZIP: function (callback) {
        var self = this;
        var src = this.pendingFiles.shift();
        if (!src) {
            callback(self.files);
        } else {
            var name = src.split('/');
            name = name[name.length - 1];
            plus.zip.compressImage({
                src: src,
                dst: '_doc/' + name,
                overwrite: true,
                quality: 50
            }, function (zip) {
                self.files.push(zip.target);
                self.ZIP(callback);
            }, function () {
                //mui.toast('压缩失败！')
            });
        }
    }
};

