/**
 * Created by Administrator on 2016/12/20.
 */

(function(keyboard) {
    var openSoftKeyboard = function() {
    	var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
        if (mui.os.ios) {
           
            nativeWebview.plusCallMethod({"setKeyboardDisplayRequiresUserAction": false});
            
        } else if (mui.os.android){
            var Context = plus.android.importClass("android.content.Context");
            var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
            var main = plus.android.runtimeMainActivity();
            var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
             //强制当前webview获得焦点
//	        plus.android.importClass(nativeWebview);
//	        nativeWebview.requestFocus();
        }
    };
    keyboard.openSoftKeyboard=openSoftKeyboard;
    var autoFocus = function(obj) {
        setTimeout(function() {
            openSoftKeyboard();
            obj.focus();
            if (obj.tagName.toLowerCase() == 'textarea') {
                moveEnd(obj);
            }
        });
    };
    keyboard.autoFocus = autoFocus;
    /**
     * 预加载页面返回时为隐藏，不会自动关闭输入法，可以通过blur来关闭
     * @param {Object} isRemoveValue
     */
    function blur(isRemoveValue) {
        var ac = document.activeElement;
        ac.blur();
        if (isRemoveValue && ac.value) {
            ac.value = null;
        }
    };
    keyboard.blur = blur;
    /**
     * @description ios下textarea.onfocus 时，默认在字首，添加该方法移动到尾部
     * @param {Object} obj
     */

    function moveEnd(obj) {
        var len = obj.value.length;
        if (document.selection) {
            var sel = obj.createTextRange();
            sel.moveStart('character', len);
            sel.collapse();
            sel.select();
        } else if (typeof obj.selectionStart == 'number' && typeof obj.selectionEnd == 'number') {
            obj.selectionStart = obj.selectionEnd = len;
        }
    }
}(window.mykeyboard = {}));