/**
 * Created by Administrator on 2016/12/28.
 */

var tpl = document.getElementById('item-template');
var compile = window.Template7(tpl.innerHTML).compile();
tpl.parentNode.removeChild(tpl);

(function ($, d, w) {
    var content = d.querySelector('#list');
    var empty = d.getElementById('empty');
    var list = [];
    var param = {page: 0};
    var action;
    var warp = $('#wrap');
    var connectErr, context;
    var formatListData = function (data) {
//{{license}} / {{car_length}} {{car_type}}
        var temp = [], start = list.length;
        $.each(data, function (k, v) {
            v.name = maxLength(v.username || v.mobile);
            v.is_back = v.is_back == 1;
            v.is_carpool = v.is_carpool == 1;
            v.index = k + start;
            v.car_info=MK_carinfo(v).join(' / ');
            v.imgCtz = v.picture || app.default.avatar;
            temp.push(v);
        });
        return temp;
    };
    function MK_carinfo(obj){
    	var aa=[];
    	if(obj.license)aa.push(obj.license);
    	if(obj.car_length)aa.push(obj.car_length);
    	if(obj.car_type)aa.push(obj.car_type);
    	return aa;
    }
    //截取掉过长的字符串
    function maxLength(str, number,end) {
        str = str || "";
        number = number || 11;
        str = String(str);
        str =str.length>12?str.substring(0, number) + '...':str;
        var n = str.match(/[0-9]*/g);
        if(!end && n=="object"){
            //中文的长度
            n = number - n.join('').length;
            if(n>6){
                str = maxLength(str,6,true);
            }
        }
        return str;
    }
    //请求网络资源
    function getRES(callback) {
        app.getCarList(param).then(function (d) {
            if (typeof d != 'object') return $.toast('请求数据出错');
            var notData = d.length < app.getRow;
            callback(d);
            var pullRefresh = warp.pullRefresh();
//            console.log('d.length:'+d.length);
//            console.log('notData:'+notData);
            switch (action) {
                case "up":
                    pullRefresh.endPullupToRefresh(notData); 
                    break;
                case "down":
                	//当刷新条件后判断一下是否还有下一页数据，进行重置
                    if (!notData)pullRefresh.refresh(true);
                    pullRefresh.endPulldownToRefresh();
                    $.os.ios?pullRefresh.scrollTo(0,0,'none',0):window.scrollTo(0,0);
                    break;
            }
            setTimeout(function(){
                var noMoreEl = document.querySelector('.mui-pull-bottom-pocket');
                if (list.length == 0) {
                    empty.style.display = 'block';
                    noMoreEl&& noMoreEl.classList.remove('mui-visibility');
                } else {
                    empty.style.display = 'none';
                    noMoreEl&&noMoreEl.classList.add('mui-visibility');
                }
            },200);
        }, function (msg) {
            action == 'down' ? warp.pullRefresh().endPulldownToRefresh() : //refresh completed
            warp.pullRefresh().endPullupToRefresh(true);
        });

    }
    function pulldownRefresh() {
        action = 'down';
        param.page = 1;
        list = [];
        getRES(function (d) {
            list = formatListData(d);
            content.innerHTML = compile(list);
        });
    }
    var fis;
    window.addEventListener("onActive", function () {
        !fis && pulldownRefresh(param);
        fis = true;
    });
    $.init({
        swipeBack: false,
        pullRefresh: {
            container: "#wrap",
            down: {
                height: '50',
                auto: false,
                callback: pulldownRefresh
            },
            up: {
                height: '200',
                auto: true,
                callback: function () {
                    action = 'up';
                    param.page++;
                    getRES(function (d) {
                        d = formatListData(d);
                        list = list.concat(d);
                        var html = compile(d);
                        var firstEle = content.innerHTML;
                        if (html.length > 10)content.innerHTML = firstEle + html;
                    });
                }
            }
        }
    });
    var remarkID;
    $(content).on('tap', '.card-2', function (event) {
        var srcElement = event.srcElement;
        var index = this.dataset.index;
        // 获取不到信息的处理
        var item = list[index];
        var id = item.id;
        var btn = event.srcElement.dataset.btn;

        switch (btn) {
            case '0':
            case '1':
                app.CarFeedback({"id": id, "content": ['车已走', '电话打不通'][btn]})
                    .then(function () {
                        plus.nativeUI.toast('投诉成功！');
                    });
                this.classList.remove("call-after");
                break;
            case '2':
                this.classList.remove("call-after");
                //添加备注
                app.openInputView({
                    "placeholder": '请输入备注',
                    "type_": 'text',
                    "text": ''
                }, function (res) {
                    app.remarkCall(remarkID, res.value);
                });
                break;
            case '3':
                // 我要派单
                app.confirm('是否与车主谈妥？', '提示',['取消', '是'], function (e) {
                    if (e.index == 1) {
                        app.$openWindow('car-dispatchOrder.html', function (ws) {
                            var sItem = JSON.stringify(item);
                            ws.evalJS('window.initContent&&initContent(' + sItem + ')');
                            setTimeout(function () {
                                $.fire(ws, 'refContent', item);
                            }, 800);
                        });
                    }
                    return true;
                });
                break;
            case 'tel':
            	if(!app.checkAuthCall(item.mobile)){break;}
                //拨打电话,
                if (mui.os.plus) plus.device.dial(item.mobile, false);
                //添加通话记录
                app.addCall(item.id, function (id) {
                    remarkID = id;
                });
                callAction(this,item.name);
                break;
            case "back":
                this.classList.remove("call-after");
                break;
            default :
                openDetailView(this,id)
        }
    }, false);
    w.refresh = function (data) {
        data = data || {};
        param.page = 1;
        
        pulldownRefresh($.extend(param, data));
    };
    w.addEventListener("matchCarParam",function(e){
        var id = e.detail.goods_id;
        if(!id)return $.toast('订单已失效，无法筛选');
        waiting.show();
        app.post('ShipperMyGoods/detail/', {"id": id}).then(function (res) {
            var P ={};
            var key =["start_province", "start_city", "start_district",  "arrive_province",
                "arrive_city", "arrive_district", "trunk_type", "trunk_length"];
            //获取筛选参数
            $.each(key,function(k,val){
               var v = res[val] ;
               if(v){
                   P[val] = v;
               }
            });
            waiting.close();
            refresh(P);
        }, function (e) {
            $.fire(app.view.parent(),"matchCar",{"reset":true});
            waiting.close();
        });
    });

})(mui, document, window);


