/**
 * Created by Administrator on 2017/1/20.
 */
// 依赖 mui.js ,app.js
mui.plusReady(function () {

    var mask,
        selfView,
        selfURL,
        webPop,
        parent,
        StatusBarBackground
    $ = mui; //状态栏颜色
    function getParentView() {
        selfView = app.view;
        var id = app.view.id;
        selfURL = ["HBuilder", "H59D8964D"].indexOf(id) > -1 ? 'www/' : '';
        parent = selfView.parent();
    }

    var closeMask = $.noop, maskIsOpen;
    /**
     *
     * @param {Object} url
     * @param {Object} data
     * @param {Object} callBack
     * @param {Object} styles
     * @param {Object} maskColor
     * @param {Object} AnimationTypeShow
     * @param {Object} isSetStatusBarBackground
     */
    var openPopView = function (url, data, callBack, styles, maskColor, AnimationTypeShow, isSetStatusBarBackground) {
        if (!parent) {
            getParentView();
        }
        maskIsOpen && closeMask();
        StatusBarBackground = plus.navigator.getStatusBarBackground();
        StatusBarBackground = StatusBarBackground && StatusBarBackground.toLocaleLowerCase()
        var style = {
            top: '30%',
            bottom: 0,
            bounce: 'none',
            scrollIndicator: 'none',
            popGesture: "none",
            zindex: 99
        };
        if (typeof styles == 'object') {
            for (var key in styles) {
                style[key] = styles[key];
            }
        }
        if (!selfView) return false;
        webPop = plus.webview.create(selfURL + url, url, style);
        mask = parent || selfView;
        closeMask = function () {
            webPop.close();
            StatusBarBackground && plus.navigator.setStatusBarBackground(StatusBarBackground);
            mask.setStyle({
                mask: "none"
            });
            maskIsOpen = false;
        };
        maskIsOpen = true;
        mask.addEventListener('maskClick', closeMask);
        webPop.onloaded = function () {
            var color = StatusBarBackground == '#ff9624' ? '#995A17' : '#999999';
            if (!isSetStatusBarBackground) {
                plus.navigator.setStatusBarBackground(color);
            }
            var aniShow = $.os.android ? "fade-in" : "slide-in-bottom";
            webPop.show(AnimationTypeShow || aniShow);
            setTimeout(function () {
                mask.setStyle({
                    mask: maskColor || 'rgba(0,0,0,0.4)',
                    transition: {
                        duration: 150
                    }
                });
            });
            webPop.evalJS('window.refresh&&refresh(' + JSON.stringify(data) + ')');
        };

        webPop.onclose = closeMask;
        window.PopViewCallBack = function (data) {
            callBack && callBack(data);
            closeMask();
        };
    };

    //打开设置日期时间段
    function setDatetime(data, callBack) {
        if (typeof data == 'function') {
            callBack = data;
            data = {};
        }
        openPopView('view-datetime.html', data, callBack);
    }

    //打开地址选择
    function openAddress(data, callBack) {
        var d = data || {};
        d.title = d.title || '请选择';
        if (d.hasDetailed) {
            openPopView('view-addressEdit.html', d, callBack, {"top": 0, "background": "transparent"});
        } else {
            openPopView('view-address.html', d, callBack);
        }

    }

    //
    function carUsage(callBack) {
        openPopView('view-carUsage.html', {}, callBack);
    }

    //车辆路程类型
    function carType(data, callBack) {
        openPopView('view-carType.html', data, callBack,
            {top: '97px', right: 0, height: "130px", "width": '90px'},
            'rgba(0,0,0,0)', "fade-in", true);
    }

    //长宽高输入
    function sizeInput(data, callBack) {
        openPopView('view-sizeInput.html', data, callBack, {
            top: null,
            bottom: '0px',
            height: "314px"
        }, 'rgba(0,0,0,0.4)', "fade-in");
    }

    //文本输入
    function openInputView(data, callBack) {
        if (typeof data != typeof {} || !window.plus) {
            return false;
        }
        data.viewId = webView.id;
        var view = $.openWindow({
            "url": 'modal.html', "styles": {
                bottom: 0,
                bounce: 'none',
                softinputMode: "adjustResize", //adjustPan  adjustResize
                scrollIndicator: 'none',
                popGesture: "none",
                background: "transparent"
            }, "show": {
                aniShow: "none"
            }
        });
        view.onloaded = function () {
            view.evalJS('window.refresh&&refresh(' + JSON.stringify(data) + ')');
        };
        window.inputUpDataModal = function (data) {
            callBack && callBack(data);
        };
    }

    var timer = setInterval(function () {
        if (window.app != undefined) {
            app.setDatetime = setDatetime;
            app.openInputView = openInputView;
            app.sizeInput = sizeInput;
            app.carType = carType;
            app.carUsage = carUsage;
            app.openAddress = openAddress;
            clearInterval(timer);
        }
    }, 80);
});