mui.plusReady(function () {


    //设置 badge start
    var els = document.querySelectorAll('.mui-icon');
    var BG0 = els[0], BG1 = els[1];
    els = undefined;
    var $ = mui;

    function setBadge(data) {
        var T0, T1;
        if (typeof data === 'object') {
            T0 = parseInt(data.total1);
            T1 = parseInt(data.total2);
            if (T0) {
                T0 = T0 > 99 ? '99+' : T0;
                BG0.innerHTML = '<span class="mui-badge">' + T0 + '</span>';
            } else {
                BG0.innerHTML = '';
            }
            if (T1) {
                T1 = T1 > 99 ? '99+' : T1;
                BG1.innerHTML = '<span class="mui-badge">' + T1 + '</span>';
            } else {
                BG1.innerHTML = '';
            }
        }
//      $.fire(plus.webview.getLaunchWebview(), "msgTotal", data);
    }

    var msgTotal;
    window.addEventListener("onActive", function () {
        changeBadge();
    });

    function changeBadge() {
        msgTotal = store.get('msgTotal');
        setBadge(msgTotal);
        store.set('msgTotal');
        app.msgTotal().then(function (data) {
            if (typeof data == 'object' && msgTotal != data) {
                store.set('msgTotal', data);
                setBadge(data);
            }
        }, function (msg) {
            console.log(msg);
        })
    }



	var tpl = '<div class="card-1" data-item="1" data-index={{@index}}>\
		        <div class="info">\
		            <span class="car">{{goods_type}}</span>\
		            <span class="fr">{{status}}</span>\
		        </div>\
		        <div class="location">\
		            <div class="icon icon-blue"><span>出发地：</span>{{start}}</div>\
		            <div class="icon icon-orange"><span>目的地：</span>{{arrive}}</div>\
		            <div class="icon icon-clock"><span>装货时间：</span>{{load_date}} {{load_hour}}</div>\
		        </div>\
		    </div>';

//  //设置 badge end
//  var tpl = '<div class="row-2 mui-table-view-cell mui-row mui-transitioning" data-id="{{id}}">\
//              <div class="mui-slider-right mui-disabled">\
//                  <a class="mui-btn mui-btn-red my-btn" data-btn="delete">删除</a>\
//              </div>\
//              <div class="mui-slider-handle my-btn" data-btn="msg">\
//                  <div class="avatar fl" style="background-image: url({{picture}})">&nbsp;</div>\
//                  <div class="info fr">\
//                      <h4>{{name}}<span class="fr">&nbsp;</span></h4>\
//                      <div class="mui-ellipsis">{{content}}</div>\
//                  </div>\
//              </div>\
//          </div>';
    var parse = function (arr) {
        var str = '';
        for (var key = 0, len = arr.length; key < len; key++) {
            var item = arr [key];
            if (typeof item == 'object') {
                str += tpl.replace('{{@index}}', item.id)
                    .replace('{{goods_type}}', item.goods_type)
                    .replace('{{status}}', item.status)
                    .replace('{{start}}', item.start)
                    .replace('{{arrive}}', item.arrive)
                    .replace('{{load_date}}', item.load_date)
                    .replace('{{load_hour}}', item.load_hour);
            }

        }
        return str;
    };
    var action = "up", context;
    // 延时更新内容渲染，避免争夺系统资源，低配置的设备可以更快速的显示
    setTimeout(function () {
        changeBadge();
        $.init({swipeBack: false});
        var list = [];
        var content = document.getElementById("list");
        $('#pullrefresh').$$pullRefresh({
            "down": {
                "contentnomore": '没有更多的消息',
                "callback": function () {
                    action = "down";
                    var self = this;
                    context = self;
                    getMsgList(context, action, function (data) {
                        content.innerHTML = parse(data);
                        self.refresh();
                        self.endPulldownToRefresh();
                    });
                }
            },
            "up": {
                "auto": true,
                "offset": 300,
                "show": true,
                "contentnomore": '没有更多的消息',
                callback: function () {
                    var self = this;
                    action = "up";
                    context = self;
                    getMsgList(context, action, function (data) {
                        content.innerHTML = parse(data);
                        self.refresh();
                        self.endPullupToRefresh(true);
                    });
                }
            }
        });

        function getMsgList(context, action, callback) {
            app.post('ShipperMyGoods/list_fabuzhong').then(function (data) {
                list = data[1];
                callback(list);
            }, function () {
                context.refresh();
                switch (action) {
                    case "up":
                        context.endPullupToRefresh(true);
                        break;
                    case "down":
                        context.endPulldownToRefresh();
                        break;
                }
                //请求失败页面显示的内容
                content.innerHTML = '<p class="tc" style="padding-top: 45px;">请求网络失败，下拉可刷新<p>';
            });
        }

        //数据已完结时
        function isEnd() {
            context.refresh();
            context.endPullupToRefresh(true);
            context.endPullupToRefresh(true);
        }
		
		var content = document.getElementById('list');
		$(content).on('tap', '.card-1', function (event) {
			var item = this.dataset.item;
	        var index = this.dataset.index;
	        if( item ==undefined||index==undefined) return false;
	        var ul = list[0];
	        if(typeof ul !=typeof []) return $.toast('操作失败');
	            
			//打开待接单详情
	        $.openWindow({
	            "url": 'todo-incomplete-order.html',
	            'id': 'incomplete-order',
	            "styles": {"scrollIndicator": "none"},
	            "extras": {"goodId": index},
	            "waiting": {"autoShow": false}
	        });
		});
		
		
        $(document).on('tap', '.my-btn', function () {
            var btn = this.dataset.btn;
            var el = this;
            var li;
            var href = this.dataset.href;
            $.openWindow({
                "url": href,
                "id": href,
                "styles": {"bounce": "none", "scrollIndicator": 'none'},
                "waiting": {"autoShow": false}
            });
               
        });

    }, 150);

    function getItem(list, id) {
        var item;
        for (var key in list) {
            var val = list[key];
            if (val && val.id == id) {
                item = val;
                return item;
            }
        }
        return item;
    }

});
