/**
 * Created by Administrator on 2017/3/30.
 */
(function ($) {
    var content = app.byId('content');
    var tpl = app.byId('content-template');
    var compile = window.Template7(tpl.innerHTML).compile();
    tpl.parentNode.removeChild(tpl);  //清除掉模板的dom
    var formData = {}; //表单数据
    var initReEditCargo; //编辑重发的原始数据；
    var checkedForm = true; //默认需要检查表单数据
    var bindEvent = function (goods) {
        var UIswitch = $('.mui-switch');
        UIswitch['switch']();
        var init = false;
        if (typeof goods == 'object') {
            init = true;
        }
        // 发票，拼车
        UIswitch.each(function () {
            var id = this.id;
            if (init && goods[id] == 1) {
                this.classList.add('mui-active');
            }
            this.addEventListener('toggle', function (event) {
                formData[id] = (event.detail.isActive ) ? 1 : 0;
            });
        });
    };
    
    //货物名称回调
//  window.goods_nameCallBack = function (data) {
//      document.getElementById("name").value=data;
//  };
    //点击事件
    $(document).on('tap', '.zbtn', function (eve) {
        var btn = this.dataset.btn;
        var html = this;
        switch (btn) {
            case "history":
                openHistory();
                break;
            case 'start':
            case 'arrive':
                var titleTxt = {"start": "出发地", "arrive": "目的地"}[btn];
                var street = checkedForm == true;
                var opts = {title: titleTxt, hasDetailed: street, free: [false, true, true]};
                app.openAddress(opts, function (data) {
                    formData[btn] = data.select||data;
                    html.querySelector('.fr').innerText = setAdsStr(btn, data.select||data);
                    var input = html.nextElementSibling;
                    if(input.nodeName=='INPUT'){
                        input.value = data.street||'';
                        data.street==''?(input.style.display=''):(input.style.display='block');
                    }
                });
                break;
            case 'time':
                app.setDatetime(function (res) {
                    formData.load_time = res.date;
                    formData.load_hour = res.time;
                    html.querySelector('.fr').innerText = res.str;
                });
                break;
//          case 'goods_name':
//          	 $.openWindow({
//	                url: 'cargo-select.html',
//	                id: 'cargo-select',
//	                waiting: {
//	                    autoShow: false
//	                }
//	            });
//          	break; 
            case 'goods_volume':
                var txt = html.querySelector('.fr');
                var number = ['', '', ''], text = txt.innerText;
                if (text) {
                    var arr = text.split('*');
                    number = (arr.length == 3 ? arr : number);
                }
                app.sizeInput(number, function (data) {
                    var str = data.join('*');
                    formData[btn] = str;
                    txt.innerText = str;
                });
                break;
            case 'usage':
                //用车需求
                app.carUsage(function (res) {
                	console.log('MP-------'+JSON.stringify(res));
                    formData.trunk_type = res.type;
                    formData.type_name = res.type_name;
                    formData.trunk_length = res.length;
                    formData.usage = res.str;
                    html.querySelector('.tx').innerText = res.str;
                });
                break;
            case 'pic':
                var key = this.dataset.index;
                photoBrowserImg(key);
                break;
            case 'remark':
                //添加备注
                remark(this);
                break;
            case 'cancel':
                $.back();
                break;
            case 'confirm':
            case 'submit':
                //提交表单
                subForm();
                break;
        }
    }, false);

    //历史发货
    function openHistory() {
        $.buffer(function () {
            $.openWindow({
                url: 'DeliverGoods-history.html',
                id: 'history',
                waiting: {
                    autoShow: false
                }
            });
        }, 1500, this)();
    }

    window.openHistory = openHistory;
    //检查数据
    var send = false, cansub = true, errK = [];

    function checkFormData() {
        if (!cansub) {
            send = false;
            var Tips = {
                "start": '请输入出发地',
                "arrive": '请输入目的地',
                "name": '请输入货物名称',
                "goods_type": '请输入货物名称',
                "time": '请输入装货时间'
            };
           
            $.toast(Tips[errK.shift()]);
            errK = [];
            cansub = true;
            return false;
        }
        return true;
    }

    //提交表单数据出错处理
    var subErr = function (e) {
    	console.log('出错了 '+e);
        waiting.close();
        send = false;
        cansub = true;
        $.toast(e);
    };
    //对比两个对象是否一样
    function EQ_obj(obj, $obj) {
        var EQ;
        $.each(obj, function (k, v) {
            if (typeof v == 'object') {
                EQ = EQ_obj(v, $obj[k]);
            } else {
                if ($obj && $obj[k] != v) {
                    switch (k) {
                        case "hasGoods_desc":
                        case "need":
                            break;
                        default :
                            EQ = true;
                    }
                    console.log(k);
                    console.log(v);
                }
            }
        });
        return EQ;
    }

    //提交表单
    function subForm() {
        if (send == true) return false;
        send = true;
        var $tempData = mui.extend({},{},formData);
        var mastKey = ["start", "arrive"];
        var FKey = Object.keys(formData);
        $.each(mastKey, function (key, val) {
            if (FKey.indexOf(val) < 0) {
                cansub = false;
                errK.push(val);
            }
        });

        $('input').each(function (k, val) {
            var key = val.id;
            switch (key) {
                case "name":  //暂时只检测是否填写货物名称
                    if (val.value) {
                        $tempData[key] = val.value.toString();
                    } else {
                        cansub = false;
                        errK.push(key);
                    }
                    break;
                default :
                    if (val.value) {
                        $tempData[key] = val.value;
                    }
            }
        });
        if (checkedForm) {
            if (!checkFormData()) {
                send = false; cansub = true;
                return false;
            }
        } else {
            //TODO 编辑重发的判断有没有修改了数据
            //看看修改了数据没有？
            //if (!EQ_obj(formData, initReEditCargo)) {
            //    send = false;
            //    cansub = true;
            //    return $.toast('没有修改，不能提交');
            //} else {
            //    //清除掉没有修改的部分键值
            //}
        }
        waiting.show("上传中");
        var fs = [];
        $.each(formData.img, function (k, val) {
            fs.push(val);
        });
        app.getUploadBridge(fs, function (imgNames) {
            $tempData.img = imgNames;
            var objStar = $tempData.start_c||($tempData.start[1].region_name=='不限'?$tempData.start[0].region_name:$tempData.start[1].region_name),
            objArrive = ($tempData.arrive[1].region_name=='不限'?$tempData.arrive[0].region_name:$tempData.arrive[1].region_name);
            if(typeof $tempData.start =="object"){
            	objStar=($tempData.start[1].region_name=='不限'?$tempData.start[0].region_name:$tempData.start[1].region_name),
               delete $tempData.start;
            }
            if(typeof $tempData.arrive =="object"){
               delete $tempData.arrive;
            }
            app.deliverGoods($tempData).then(function (done) {
                $tempData.start = objStar;
                $tempData.arrive = objArrive;
                send = false;
                cansub = true;
                waiting.close();
                if (checkedForm) {
                    var ss = mui.extend({},formData,$tempData);
                    ss.id = done;
                    if (!ss.name) {
                        ss.name = ss.goods_type;
                    }
                    if(ss.usage!=undefined){
                    	if(ss.trunk_length!=0){
                    		ss.carTypeStr = ss.trunk_type==0?(ss.trunk_length+'米'):(ss.trunk_length+'米'+ss.type_name);
                    	}else{
                    		ss.carTypeStr = ss.usage;
                    	}
                    }
                    plus.storage.setItem('newPostGoods', JSON.stringify(ss));
                    //成功！！还原页面，清空数据，跳转
                    var DeliverGoodsSuccess =
                        $.openWindow({
                            url: 'DeliverGoods-success.html', id: "DeliverGoods-success", styles: {
                                "background": "#FFFFFF", //
                                "bounce": 'none',
                                "scrollIndicator": 'none'
                            }, "show": {
                                "autoShow": true   //页面loaded事件发生后自动显示，默认为true
                            },
                            "waiting": {
                                "autoShow": false
                            }
                        });
                    DeliverGoodsSuccess.onloaded = function () {
                        plus.navigator.setStatusBarBackground(app.default.statusBarBackground);
                        setTimeout(function () {
                            formData = {};
                            refreshContent();
                        }, 250);
                        cansub = true;
                        return false;
                    };
                } else {
                    $.toast('编辑成功');
//                  var Pws = app.view.opener();
					var Pws = app.view.opener().opener();
                    Pws.reload();
                    Pws.onloaded = function () {
                        waiting.close();
                        app.view.close();
                        app.view.opener().close();
//                      $.back().back();
                    }
                }
            }).catch(function (msg) {
                waiting.close();
                send = false;
                cansub = true;
                $.toast('提交失败 ' + msg);
            });

        });
    }

    function remark() {
        if ($.os.plus) {
            if (plus.webview.getWebviewById("Goods-desc")) return false;
            var descView = $.openWindow({
                url: 'DeliverGoods-desc.html', id: "Goods-desc", styles: {
                    background: "#FFFFFF", //
                    bounce: 'none',
                    scrollIndicator: 'none',
                    popGesture: 'none'
                }
            });
            descView.show('pop-in');
            descView.onloaded = function () {
                descView.evalJS('initDescData(' + JSON.stringify({
                    "text": formData.goods_desc,
                    "files": formData.img
                }) + ')');
            };
        }
    }

    //编辑重发的备注处理
    function reEditRemark(data) {
        app.byId('desc_text').innerText = data.text;
        var str = picHtml(data.files);
        if (data.files.length < 10) {
            str += '<div class="pic add zbtn" data-btn="remark"></div>';
        }
        app.byId('gallery').innerHTML = str;
    }

    // 描述事件接收
    window.descDone = function (data) {
        //一键发货
        if (checkedForm) {
            var _note = app.byId("_note");
            // 备注信息
            var descEl = app.byId("desc_text");
            // 备注图片
            var gallery = app.byId('gallery');
            if (data.text) {
                if (descEl) {
                    descEl.innerHTML = '<p class="ps">' + data.text + '</p>';
                } else {
                    var str = '<li class="mui-table-view-cell zbtn" data-btn="remark" id="desc_text"><p class="ps">' + data.text + '</p></li> ';
                    descEl = app.dom(str);
                    //已有图片列表则插入到列表前面
                    try {
                        gallery ? _note.insertBefore(descEl, gallery.parentNode) : _note.appendChild(descEl);
                    } catch (e) {
                        //console.log('检查是子节点还是孙子节点');
                        return true;
                    }
                }
            } else if (descEl) {
                descEl.parentNode.removeChild(descEl);
            }
            //图片列表操作
            if (data.files && data.files.length > 0) {
                if (gallery) {
                    gallery.innerHTML = picHtml(data.files);
                } else {
                    _note.appendChild(app.dom('<li class="mui-table-view-cell"><div class="gallery" id="gallery">' + picHtml(data.files) + '</div></li>'));
                }
            } else if (gallery) {
                gallery.parentNode.removeChild(gallery);
            }
        } else {
            //编辑重发
            reEditRemark(data);
        }
        formData.goods_desc = data.text;
        formData.img = data.files;
        //$.previewImage();
    };
    function photoBrowserImg(key){
        //浏览图片
        var showCB = function () {
            var p = {
                "img": formData.img,
                "index": key,
                "showDelete": true,
                "autoOpen": true
            };
            p = JSON.stringify(p);
            setTimeout(function () {
                photoBrowser.evalJS('open(' + p + ')');
            }, 50);
        };
        var photoBrowser = plus.webview.getWebviewById("photoBrowser");
        if (photoBrowser) {
            photoBrowser.show('none', 0, showCB);
        } else {
            photoBrowser = plus.webview.create('photoBrowser.html', "photoBrowser", {
                "background": 'transparent',
                "bounce": 'none',
                "scrollIndicator": 'none',
                "popGesture": 'none'
            });
            photoBrowser.show('none', 0, showCB);
        }
        photoBrowser.onclose=function(){

        }
    }
    //删除 图片
    window.addEventListener('deleteImg', function (event) {
        var target = event.detail.Img;
        $.each(formData.img,function(k,val){
            if(val==target){
            	formData.img.splice(k,1);
            }
        });
        descDone({"text":formData.goods_desc,"files":formData.img});
    });
    // 循环出备注图片的innerHTML
    function picHtml(arr) {
        var html = '';
        for (var i in arr) {
            html += '<div class="pic zbtn" data-btn="pic" data-index="'+i+'"><img src="' + arr[i] + '"/></div>'
        }
        return html;
    }

    //获取定位并且设置
    function setGeolocation() {
        app.parseGeolocation(function (data, geolocation) {
            $.each(data, function (k, val) {
                formData['start_' + k] = val;
            });
            var str = geolocation.address.city + ' ' + geolocation.address.district;
            formData.start_c = geolocation.address.city;
            formData.start = str;
            var startEl = document.querySelector('span.fr');
            startEl.innerText = str;
            var input = startEl.parentElement.nextElementSibling;
            if (input && input.nodeName == "INPUT") {
                input.value = geolocation.address.street;
                input.style.display = 'inline-block';
            }
        });
    }

    //刷新内容
    function refreshContent(goods) {
        if (!goods) {
            // 如果不为重新编辑 才执行定位；
            if (window.plus) {
                setGeolocation()
            } else {
                $.plusReady(function () {
                    setGeolocation()
                });
            }
        }
        content.innerHTML = compile(contentAdapter(goods));
        var inputs =$("input");
        if(goods&&goods.start_address){
              if(inputs[0]){
              	inputs[0].value =goods.start_address;
              	inputs[0].style.display = 'inline-block';
              }
              
        }
        if(goods&& goods.arrive_address){
        	if(inputs[1]){
        		inputs[1].value =goods.arrive_address;
              	inputs[1].style.display = 'inline-block';
              }
        }

        //$.previewImage();
        if (checkedForm && goods) {
            formData = goods;
        }
        bindEvent(goods);
        // 删除表单多余的字段
        deleteAttr();
    }
    //refreshContent();
    // 删除表单多余的字段
    function deleteAttr() {
        //多余的字段名
        var keys = [
            "volume", "$need", "hasGoods_desc", "hasImg", "id", "img_show", "user_id", "status", "issue_time",
            "end_time", "trunk_type_show", "hasNote", "load_time", "load_hour", "mile", "status_code", "owner_mobile"];
        $.each(formData, function (key, val) {
            if (keys.indexOf(key) > -1 || !val) {
                delete formData[key];
            }
        });
        if (!checkedForm) {
            initReEditCargo = $.extend({}, formData);
        }
    }

    // 内容适配
    function contentAdapter(data) {
        if (typeof data != "object") return {};
        data.hasImg = data.img && data.img.length > 0;
        if (data.hasImg) {
            data.tempImgIDs = data.img;
            data.img = data.img_show;
        }
        data.goods_weight = !data.goods_weight?'':data.goods_weight;
        data.hasGoods_desc = data.goods_desc && (data.goods_desc.replace(/\s+/g, '')).length > 0;
        var _type = data.trunk_type_show || '';
        var len = _UnZero(data.trunk_length);
        data.need = _type + ' ' + len;
        if (!data.need.replace(/\ */, '')) {
            data.need = '不限';
        }
        if (data.goods_volume && /\*/.test(data.goods_volume)) {
            data.volume = data.goods_volume
        } else {
            data.volume = '';
        }
        return data;
    }

    function _UnZero(s) {
        if (!s || s == '0.0') {
            s = '';
        }
        return s;
    }

    /**
     *  编辑重发才会有view上的数据；一键发货只会在刷新时填入数据
     */
    $.plusReady(function () {
        var goods = app.view.goods;
        if (goods) {
            //编辑重发需要保留ID.
            goods.edit_id = goods.id;
            goods.name = goods.goods_type;
            delete goods.id;
            formData = goods;
            checkedForm = false;   //不需要再检查数据
        }
        refreshContent(goods);
    });
    //refreshContent(); //浏览器调试使用
    //监听来自历史记录的事件
    window.addEventListener("reSteContent", function (event) {
        var id = event.detail.id;
        //请求详情
        waiting.show();
        app.post('ShipperMyGoods/detail/', {"id": id}).then(function (res) {
            waiting.close();
            refreshContent(res)
        }, function (e) {
            waiting.close();
            $.toast(e);
        });
    }, false);
    // 序列化 地址字符串
    var addressArr = ['province', 'city', 'district'];

    function setAdsStr(id, data) {
        var s = '';
        for (var i in data) {
            s += ' ' + data[i].region_name;
            formData[id + '_' + addressArr[i]] = data[i].region_id;
        }
        return s
    }

    // 其它操作时去掉input的光标
    document.addEventListener("touchstart", function (event) {
        var targetNode = event.srcElement.nodeName;
        if (targetNode != 'INPUT') {
            $('input').each(function () {
                this.blur()
            });
        } else {
            //滚一下视窗
            setTimeout(function () {
                document.activeElement.scrollIntoViewIfNeeded();
            });
        }
    }, false);
    
})(mui);
